package com.tofly.feesapi.common.dzfp;

import com.tofly.common.core.util.StringUtil;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.dzfp.entity.EiFpkjMx;
import com.tofly.feesapi.dzfp.entity.EiFpkjRequest;
import com.tofly.feesapi.dzfp.entity.EiSalerConfig;
import com.tofly.feesapi.dzfp.entity.EiSpbm;
import com.tofly.feesapi.dzfp.service.EiFpkjMxService;
import com.tofly.feesapi.dzfp.service.EiFpkjRequestService;
import com.tofly.feesapi.dzfp.service.EiSalerConfigService;
import com.tofly.feesapi.dzfp.service.EiSpbmService;
import com.tofly.feesapi.sfgl.entity.YyQfmx;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Objects;

@Service
public class InvoiceService {
    @Autowired
    private EiFpkjMxService eiFpkjMxService;
    @Autowired
    private EiFpkjRequestService eiFpkjRequestService;
    @Autowired
    private EiSpbmService eiSpbmService;

    @Autowired
    private EiSalerConfigService eiSalerConfigService;


    public void addInvoiceData(List<YyQfmx> yyQfmxs, YhKhjbxx yhKhjbxx,
                               String sfryxm, BigDecimal scye, BigDecimal bcye) {
        //默认分批次开票
        Integer xh = 0;
        if (true) {
            for (YyQfmx yyQfmx : yyQfmxs) {
                String lsbh = GuidGenerator.getGuid(); // 流水编号
                // 添加发票项目明细数据,调用方法并获取返回值
                InvoiceAmounts amounts = addInvoiceItem(yyQfmx, lsbh, xh);

                // 使用返回的参数
                Double taxExcludedAmount = amounts.getTaxExcludedAmount();//汇总不含税金额
                Double tax = amounts.getTax();//合计税
                Double taxIncludedAmount = amounts.getTaxIncludedAmount();//含税金额
                // 添加发票汇总数据
                String remark = "用户编号:" + yyQfmx.getYhbh() + ",抄表月份:" + yyQfmx.getCwrq() +
                        ",起数(吨):" + yyQfmx.getScds() + ",止数(吨):" + yyQfmx.getBcds() +
                        ",加减量:" + yyQfmx.getJjl() + ",水量(吨):" + yyQfmx.getSl() +
                        ",上次结转:" + String.format("%.2f", scye) +
                        ",本次结转:" + String.format("%.2f", bcye);
                addInvoiceSummary(yyQfmx, yhKhjbxx, lsbh, remark, sfryxm, "0", taxExcludedAmount, tax, taxIncludedAmount);
            }
        } else {//合并开票
            String lsbh = GuidGenerator.getGuid(); // 流水编号
            InvoiceAmounts amounts = new InvoiceAmounts(0d, 0d, 0d);
            for (YyQfmx yyQfmx : yyQfmxs) {
                amounts = new InvoiceAmounts(amounts, addInvoiceItem(yyQfmx, lsbh, xh));
            }
            //重新组装需要的欠费明细字段
            YyQfmx yyQfmx = new YyQfmx();
            yyQfmx.setYhbh(yyQfmxs.get(0).getYhbh());
            yyQfmx.setSsgs(yyQfmxs.get(0).getSsgs());
            yyQfmx.setSscbpq(yyQfmxs.get(0).getSscbpq());
            yyQfmx.setCbkh(yyQfmxs.get(0).getCbkh());
            yyQfmx.setCwrq(yyQfmxs.size() > 1 ? yyQfmxs.get(0).getCwrq() + "-" + yyQfmxs.get(yyQfmxs.size() - 1).getCwrq() : yyQfmxs.get(0).getCwrq());
            yyQfmx.setScds(yyQfmxs.get(0).getScds());
            yyQfmx.setBcds(yyQfmxs.get(yyQfmxs.size() - 1).getBcds());
            yyQfmx.setSflsbh(yyQfmxs.get(0).getSflsbh());
            yyQfmx.setJjl(yyQfmxs.stream().map(YyQfmx::getJjl).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add));
            yyQfmx.setSl(yyQfmxs.stream().map(YyQfmx::getJjl).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add));
            yyQfmx.setYsje(yyQfmxs.stream().map(YyQfmx::getYsje).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add));
            String remark = "用户编号:" + yyQfmx.getYhbh() + ",抄表月份:" + yyQfmx.getCwrq() +
                    ",起数(吨):" + yyQfmx.getScds() + ",止数(吨):" + yyQfmx.getBcds() +
                    ",加减量:" + yyQfmx.getJjl() + ",水量(吨):" + yyQfmx.getSl() +
                    ",上次结转:" + String.format("%.2f", scye) +
                    ",本次结转:" + String.format("%.2f", bcye);
            Double taxExcludedAmount = amounts.getTaxExcludedAmount();//汇总不含税金额
            Double tax = amounts.getTax();//合计税
            Double taxIncludedAmount = amounts.getTaxIncludedAmount();//含税金额
            addInvoiceSummary(yyQfmx, yhKhjbxx, lsbh, remark, sfryxm, "1", taxExcludedAmount, tax, taxIncludedAmount);
        }
    }

    private InvoiceAmounts addInvoiceItem(YyQfmx yyQfmx, String lsbh, Integer xh) {

        EiFpkjMx eiFpkjMx = new EiFpkjMx();
        Double Hj_Taxexcludedamount = 0d;//不含税金额
        Double Hj_Tax = 0d;//税额
        Double Hj_Taxincludedamount = 0d;//含税金额

        //不含税金额 税额 含税金额
        //判断污水费
        if (yyQfmx.getSl().doubleValue() > 0 && yyQfmx.getWsf().doubleValue() > 0) {

            EiSpbm eiSpbm = eiSpbmService.getById("002"); // 污水费
            eiFpkjMx.setMxid(GuidGenerator.getGuid());
            eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
            eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
            eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
            eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
            eiFpkjMx.setPrice(yyQfmx.getSl().doubleValue()); // 单价
            eiFpkjMx.setNum(yyQfmx.getSl().doubleValue()); // 数量
            eiFpkjMx.setUnit(eiSpbm.getUnit()); // 单位
            eiFpkjMx.setSpectype("无");//规格型号
            eiFpkjMx.setTaxrate(0d); // 税率
            eiFpkjMx.setTax(0d); // 税额
            eiFpkjMx.setTaxexcludedamount(yyQfmx.getWsf().doubleValue()); // 不含税金额
            eiFpkjMx.setTaxincludedamount(yyQfmx.getWsf().doubleValue()); // 含税金额

            eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
            eiFpkjMx.setFavouredpolicyflag("03"); // 优惠政策
            eiFpkjMx.setFavouredpolicyname(""); // 优惠政策名称
            eiFpkjMx.setZerorateflag("1"); // 零税率标识
            eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
            eiFpkjMxService.save(eiFpkjMx);

            Hj_Tax = Hj_Tax + eiFpkjMx.getTax();//合计 含税金额
            Hj_Taxexcludedamount = Hj_Taxexcludedamount + eiFpkjMx.getTaxexcludedamount();//合计 不含税金额
            Hj_Taxincludedamount = Hj_Taxincludedamount + eiFpkjMx.getTaxincludedamount();// 含税金额
        }
        //判断违约金
        if (yyQfmx.getZnj() != null && yyQfmx.getZnj().doubleValue() > 0) {
            EiSpbm eiSpbm = eiSpbmService.getById("003"); //违约金
            eiFpkjMx.setMxid(GuidGenerator.getGuid());
            eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
            eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
            eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
            eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
            eiFpkjMx.setPrice(yyQfmx.getSl().doubleValue()); // 单价
            eiFpkjMx.setNum(yyQfmx.getSl().doubleValue()); // 数量
            eiFpkjMx.setSpectype("无");//规格型号
            eiFpkjMx.setUnit("吨"); // 单位
            eiFpkjMx.setTaxrate(0d); // 税率
            eiFpkjMx.setTax(0d); // 税额
            eiFpkjMx.setTaxexcludedamount(yyQfmx.getZnj().doubleValue()); // 不含税金额
            eiFpkjMx.setTaxincludedamount(yyQfmx.getZnj().doubleValue()); // 含税金额
            eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
            eiFpkjMx.setFavouredpolicyflag("03"); // 优惠政策
            eiFpkjMx.setFavouredpolicyname(""); // 优惠政策名称
            eiFpkjMx.setZerorateflag("1"); // 零税率标识
            eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
            eiFpkjMxService.save(eiFpkjMx);
            Hj_Taxexcludedamount = Hj_Taxexcludedamount + yyQfmx.getWsf().doubleValue();//合计 不含税金额
            Hj_Tax = Hj_Tax;//合计 含税金额
            Hj_Taxincludedamount = Hj_Taxincludedamount + yyQfmx.getWsf().doubleValue();// 含税金额
        }
        //判断水费,是否免税
        if (yyQfmx.getSl().doubleValue() > 0 && yyQfmx.getYsje().doubleValue() > 0) {
            EiSpbm eiSpbm = eiSpbmService.getById("003"); //水费
            Double taxrate = Double.valueOf(eiSpbm.getTaxrate());//税率
            eiFpkjMx.setUnit("吨"); // 单位
            eiFpkjMx.setTaxrate(taxrate); // 税率
            eiFpkjMx.setSpectype("无");//规格型号
            //按正常、
            if (yyQfmx.getCbjsbz() != null && yyQfmx.getCbjsbz().equals("0")) {
                eiFpkjMx.setMxid(GuidGenerator.getGuid());
                eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
                eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
                eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
                eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
                eiFpkjMx.setPrice(yyQfmx.getSl().doubleValue()); // 单价
                eiFpkjMx.setNum(yyQfmx.getSl().doubleValue()); // 数量

                eiFpkjMx.setTax(yyQfmx.getSf().doubleValue() / (1 + taxrate) * taxrate); // 税额
                eiFpkjMx.setTaxexcludedamount(yyQfmx.getSf().doubleValue() - eiFpkjMx.getTax()); // 不含税金额
                eiFpkjMx.setTaxincludedamount(yyQfmx.getSf().doubleValue()); // 含税金额

                eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
                eiFpkjMx.setFavouredpolicyflag("01"); // 优惠政策
                eiFpkjMx.setFavouredpolicyname("简易征收"); // 优惠政策名称
                eiFpkjMx.setZerorateflag(""); // 零税率标识
                eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
                eiFpkjMxService.save(eiFpkjMx);

                Hj_Tax = Hj_Tax + eiFpkjMx.getTax();//合计 含税金额
                Hj_Taxexcludedamount = Hj_Taxexcludedamount + eiFpkjMx.getTaxexcludedamount();//合计 不含税金额
                Hj_Taxincludedamount = Hj_Taxincludedamount + eiFpkjMx.getTaxincludedamount();// 含税金额
            }
            //阶梯
            if (yyQfmx.getCbjsbz() != null && yyQfmx.getCbjsbz().equals("1")) {
                //阶梯1
                if (yyQfmx.getJt1sl() != null && yyQfmx.getJt1sl().doubleValue() > 0) {
                    eiFpkjMx.setMxid(GuidGenerator.getGuid());
                    eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
                    eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
                    eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
                    eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
                    eiFpkjMx.setPrice(yyQfmx.getJt1sj().doubleValue()); // 单价
                    eiFpkjMx.setNum(yyQfmx.getJt1sl().doubleValue()); // 数量

                    eiFpkjMx.setTax(yyQfmx.getJt1sf().doubleValue() / (1 + taxrate) * taxrate); // 税额
                    eiFpkjMx.setTaxexcludedamount(yyQfmx.getJt1sf().doubleValue() - eiFpkjMx.getTax()); // 不含税金额
                    eiFpkjMx.setTaxincludedamount(yyQfmx.getJt1sf().doubleValue()); // 含税金额

                    eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
                    eiFpkjMx.setFavouredpolicyflag("01"); // 优惠政策
                    eiFpkjMx.setFavouredpolicyname("简易征收"); // 优惠政策名称
                    eiFpkjMx.setZerorateflag(""); // 零税率标识
                    eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
                    eiFpkjMxService.save(eiFpkjMx);

                    Hj_Tax = Hj_Tax + eiFpkjMx.getTax();//合计 含税金额
                    Hj_Taxexcludedamount = Hj_Taxexcludedamount + eiFpkjMx.getTaxexcludedamount();//合计 不含税金额
                    Hj_Taxincludedamount = Hj_Taxincludedamount + eiFpkjMx.getTaxincludedamount();// 含税金额
                }
                //阶梯2
                if (yyQfmx.getJt2sl() != null && yyQfmx.getJt2sl().doubleValue() > 0) {
                    eiFpkjMx.setMxid(GuidGenerator.getGuid());
                    eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
                    eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
                    eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
                    eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
                    eiFpkjMx.setPrice(yyQfmx.getJt2sj().doubleValue()); // 单价
                    eiFpkjMx.setNum(yyQfmx.getJt2sl().doubleValue()); // 数量

                    eiFpkjMx.setTax(yyQfmx.getJt2sf().doubleValue() / (1 + taxrate) * taxrate); // 税额
                    eiFpkjMx.setTaxexcludedamount(yyQfmx.getJt2sf().doubleValue() - eiFpkjMx.getTax()); // 不含税金额
                    eiFpkjMx.setTaxincludedamount(yyQfmx.getJt2sf().doubleValue()); // 含税金额

                    eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
                    eiFpkjMx.setFavouredpolicyflag("01"); // 优惠政策
                    eiFpkjMx.setFavouredpolicyname("简易征收"); // 优惠政策名称
                    eiFpkjMx.setZerorateflag(""); // 零税率标识
                    eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
                    eiFpkjMxService.save(eiFpkjMx);

                    Hj_Tax = Hj_Tax + eiFpkjMx.getTax();//合计 含税金额
                    Hj_Taxexcludedamount = Hj_Taxexcludedamount + eiFpkjMx.getTaxexcludedamount();//合计 不含税金额
                    Hj_Taxincludedamount = Hj_Taxincludedamount + eiFpkjMx.getTaxincludedamount();// 含税金额
                }
                //阶梯3
                if (yyQfmx.getJt3sl() != null && yyQfmx.getJt3sl().doubleValue() > 0) {
                    eiFpkjMx.setMxid(GuidGenerator.getGuid());
                    eiFpkjMx.setLsbh(lsbh);//流水编号，与汇总表关联
                    eiFpkjMx.setGoodsname(eiSpbm.getGoodname()); // 商品名称
                    eiFpkjMx.setGoodscode(eiSpbm.getGoodcode()); // 商品编码
                    eiFpkjMx.setWithtaxflag(eiSpbm.getWithtaxflag()); // 单价含税标识
                    eiFpkjMx.setPrice(yyQfmx.getJt3sj().doubleValue()); // 单价
                    eiFpkjMx.setNum(yyQfmx.getJt3sl().doubleValue()); // 数量

                    eiFpkjMx.setTax(yyQfmx.getJt3sf().doubleValue() / (1 + taxrate) * taxrate); // 税额
                    eiFpkjMx.setTaxexcludedamount(yyQfmx.getJt3sf().doubleValue() - eiFpkjMx.getTax()); // 不含税金额
                    eiFpkjMx.setTaxincludedamount(yyQfmx.getJt3sf().doubleValue()); // 含税金额

                    eiFpkjMx.setInvoicelineproperty("0"); // 发票行性质
                    eiFpkjMx.setFavouredpolicyflag("01"); // 优惠政策
                    eiFpkjMx.setFavouredpolicyname("简易征收"); // 优惠政策名称
                    eiFpkjMx.setZerorateflag(""); // 零税率标识
                    eiFpkjMx.setXh(new BigDecimal(xh++)); // 序号
                    eiFpkjMxService.save(eiFpkjMx);

                    Hj_Tax = Hj_Tax + eiFpkjMx.getTax();//合计 含税金额
                    Hj_Taxexcludedamount = Hj_Taxexcludedamount + eiFpkjMx.getTaxexcludedamount();//合计 不含税金额
                    Hj_Taxincludedamount = Hj_Taxincludedamount + eiFpkjMx.getTaxincludedamount();// 含税金额
                }
            }
        }
        return new InvoiceAmounts(Hj_Taxexcludedamount, Hj_Tax, Hj_Taxincludedamount);
    }


    private void addInvoiceSummary(YyQfmx yyQfmx, YhKhjbxx yhKhjbxx,
                                   String lsbh, String remark, String sfryxm, String fpsfhb,
                                   Double taxExcludedAmount, Double tax, Double taxIncludedAmount) {

        EiFpkjRequest eiFpkjRequest = new EiFpkjRequest();

        eiFpkjRequest.setLsbh(lsbh); // 流水编号
        eiFpkjRequest.setSfid(yyQfmx.getSflsbh()); //收费ID与收费流水编号关联
        eiFpkjRequest.setSsgs(yyQfmx.getSsgs()); // 所属公司
        eiFpkjRequest.setSspq(yyQfmx.getSscbpq()); // 所属片区
        eiFpkjRequest.setYhbh(yyQfmx.getYhbh()); // 用户编号
        eiFpkjRequest.setCbkh(yyQfmx.getCbkh()); // 抄表卡号
        eiFpkjRequest.setCwrq(yyQfmx.getCwrq()); // 财务月份
        eiFpkjRequest.setSsje(yyQfmx.getYsje().doubleValue()); // 实收金额
        eiFpkjRequest.setTaxamount(tax);//合计税额
        eiFpkjRequest.setOrderamount(taxIncludedAmount);//含税金额
        eiFpkjRequest.setExtaxamount(taxExcludedAmount);//不含税金额
        eiFpkjRequest.setSflx("1"); // 收费类型

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String strorderno = sdf.format(new Date()) + GuidGenerator.getGuid().substring(0, 6);
        eiFpkjRequest.setOrderno(strorderno);//订单号
        eiFpkjRequest.setInvoicedate(new Date().toString());//订单时间
        eiFpkjRequest.setSfry(sfryxm); // 收费人员
        eiFpkjRequest.setPayee(sfryxm);//收款人员
        eiFpkjRequest.setClerk(sfryxm);//开票人员
        eiFpkjRequest.setChecker(sfryxm);//复核人员

        eiFpkjRequest.setSfrq(new Date()); // 收费日期
        eiFpkjRequest.setRemark(remark); // 备注
        eiFpkjRequest.setBuyername(StringUtil.isNotEmpty(yhKhjbxx.getFpName()) ? yhKhjbxx.getFpName() : yhKhjbxx.getYhxm()); // 购买方
        eiFpkjRequest.setBuyertaxnum(yhKhjbxx.getFpNsrsbh()); // 购方税号
        eiFpkjRequest.setBuyertel(yhKhjbxx.getFpLxdh()); // 购方电话
        eiFpkjRequest.setBuyeraddress(yhKhjbxx.getFpDz()); // 购方地址
        eiFpkjRequest.setBuyeraccount(yhKhjbxx.getFpBankcode()); // 购方银行账号
        eiFpkjRequest.setBuyerbank(yhKhjbxx.getFpBankname()); // 购方银行
        eiFpkjRequest.setInvoicetype(yhKhjbxx.getFplx()); // 开票类型
//        eiFpkjRequest.setFpSfkp(yhKhjbxx.getSfkp());//是否开票
//        eiFpkjRequest.setPushmode(yhKhjbxx.getPushmode());//推送方式

        if (yhKhjbxx.getFplx() != null && yhKhjbxx.getFplx().equals("1")) {
            eiFpkjRequest.setInvoiceline("pc");//发票种类
        }
        if (yhKhjbxx.getFplx() != null && yhKhjbxx.getFplx().equals("2")) {
            eiFpkjRequest.setInvoiceline("bs");//发票种类
        }
        eiFpkjRequest.setSpecificfactor("0");//特定要素
        eiFpkjRequest.setListflag("0");//清单标识


        EiSalerConfig fpConfig = eiSalerConfigService.getById(1);

        eiFpkjRequest.setSalertaxnum(fpConfig.getSalertaxnum());//销方税号
        eiFpkjRequest.setSalertel(fpConfig.getSalertel());//销方电话
        eiFpkjRequest.setSaleraddress(fpConfig.getSaleraddress());//销方地址
        eiFpkjRequest.setSaleraccount(fpConfig.getSaleraccount());//销方银行账号
        eiFpkjRequest.setSalerbank(fpConfig.getSalerbank());//销方银行

        eiFpkjRequest.setProxyinvoiceflag("0");//代开标识
        eiFpkjRequest.setStatus("0");//发票状态
        eiFpkjRequest.setClLock("0");//是否锁定
        eiFpkjRequest.setClCljg("0");//处理结果
        eiFpkjRequest.setZfZfbz("0");//作废标识
        eiFpkjRequest.setJfYxbz("0");//交付有效标识
        eiFpkjRequest.setCxJfbz("0");//重新交付标识
        eiFpkjRequest.setFpCkbz("0");//发票重开标识
        eiFpkjRequest.setFpSfHb(fpsfhb);//发票是否合并开票1是0否
        if (fpsfhb.equals("1")) {
            eiFpkjRequest.setFpHbLx("1");//合并开票类型，1多笔欠费，2多用户欠费  目前默认1
        }
        eiFpkjRequestService.save(eiFpkjRequest);
    }

}
