package com.tofly.feesapi.common.znj;

import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.temporal.ChronoUnit;


/**
 * 违约金计算
 */
@Service
public class ZnjCal {
    public ZNJResult getZNJ(LocalDate cbrq, String znjJSSS, int days, double znjlv, double QFBJJE, String qflsbh) {
        double znj_je;
        LocalDate dt_znjjsksrq = LocalDate.now();

        // 按抄表当月**号以后计算
        if (znjJSSS.equals("01")) {
            if (days <= 0) {
                days = 1;
            }
            try {
                dt_znjjsksrq = LocalDate.of(cbrq.getYear(), cbrq.getMonth(), days);
            } catch (Exception e) {
                dt_znjjsksrq = LocalDate.of(cbrq.getYear(), cbrq.getMonth(), 30);
            }
        }
        // 按抄表下月**号以后计算
        else if (znjJSSS.equals("02")) {
            if (cbrq.plusMonths(1).getMonthValue() == 1) {
                cbrq = cbrq.plusYears(1);
            }
            int year = cbrq.getYear();
            int month = cbrq.plusMonths(1).getMonthValue();
            if (days <= 0) {
                days = 1;
            }
            try {
                dt_znjjsksrq = LocalDate.of(year, month, days);
            } catch (Exception e) {
                dt_znjjsksrq = LocalDate.of(year, month, 1);
            }
        }
        // 按抄表日期起**天以后计算
        else if (znjJSSS.equals("03")) {
            dt_znjjsksrq = cbrq.plusDays(days);
        }

        LocalDate dt_now = LocalDate.now();
        long znj_ts = ChronoUnit.DAYS.between(dt_znjjsksrq, dt_now);
        if (znj_ts > 0) {
            znj_je = znj_ts * znjlv * QFBJJE;
        } else {
            znj_je = 0;
        }

        // 确保znj_je不小于0
        if (znj_je < 0) {
            znj_je = 0;
        }

        // 确保znj_je在1和QFBJJE之间
        if (znj_je > 0 && znj_je < 1) {
            znj_je = 1;
        }
        if (znj_je > QFBJJE) {
            znj_je = QFBJJE;
        }
        // 保留两位小数
        znj_je = Math.round(znj_je * 100.0) / 100.0;
        //违约金额不能超过欠费
        if (znj_je > QFBJJE) {
            znj_je = QFBJJE;
        }
        double do_jmje =0;// yyQfmxMapper.selectJmje(qflsbh);
        double ys_znj = znj_je - do_jmje;
        if(znj_ts<0)
        {
            znj_ts=0;
        }
        return new ZNJResult(znj_je, znj_ts);
    }

}
