/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.dzfp.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.dzfp.entity.dto.EiFpkjMx_select;
import com.tofly.feesapi.dzfp.service.EiFpkjMxService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 电子发票明细表
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@RestController
@AllArgsConstructor
@RequestMapping("/eifpkjmx")
@Api(tags="电子发票-(根据lsbh查看开票明细)")
public class EiFpkjMxController {

    private final  EiFpkjMxService eiFpkjMxService;

    /**
     * 发票明细查询 list
     * @param lsbh
     * @return
     */
    @GetMapping("/List/{lsbh}" )
    @ApiOperation(value = "List查询")
    public ResultRespone<List<EiFpkjMx_select>>  getEiFpkjMxPage(@PathVariable("lsbh" ) String lsbh) {
        if(lsbh.isEmpty())
        {
            throw new FeesException("提示：查看发票明细流水编号不能为空！", FeesErrorCode.BUSINESS_ERROR);
        }

      return ResultRespone.success(eiFpkjMxService.getList(lsbh));
    }


//    /**
//     * 通过id查询电子发票明细表
//     * @param mxid id
//     * @return ResultRespone
//     */
//    @GetMapping("/{sfid}" )
//    @ApiOperation(value = "通过sfid查询")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "mxid", value = "sfid", required = true, dataType = "String")
//    })
//    public ResultRespone getById(@PathVariable("mxid" ) String sfid) {
//      return ResultRespone.success(eiFpkjMxService.getById(sfid));
//    }

//    /**
//     * 新增电子发票明细表
//     * @param eiFpkjMx 电子发票明细表
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="新增电子发票明细表" )
//    @ApiOperation(value = "新增电子发票明细表")
//    @PostMapping
//    public ResultRespone save(@RequestBody EiFpkjMx eiFpkjMx) {
//      return ResultRespone.success(eiFpkjMxService.save(eiFpkjMx));
//    }

//    /**
//     * 修改电子发票明细表
//     * @param eiFpkjMx 电子发票明细表
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="修改电子发票明细表" )
//    @ApiOperation(value = "修改电子发票明细表")
//    @PutMapping
//    public ResultRespone updateById(@RequestBody EiFpkjMx eiFpkjMx) {
//      return ResultRespone.success(eiFpkjMxService.updateById(eiFpkjMx));
//    }

//    /**
//     * 通过id删除电子发票明细表
//     * @param mxid id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id删除电子发票明细表" )
//    @ApiOperation(value = "通过ID删除电子发票明细表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "mxid", value = "ID", required = true, dataType = "String")
//    })
//    @DeleteMapping("/{mxid}" )
//    public ResultRespone removeById(@PathVariable String mxid) {
//      return ResultRespone.success(eiFpkjMxService.removeById(mxid));
//    }

//    /**
//     * 通过id批量删除电子发票明细表
//     * @param ids id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id批量删除电子发票明细表" )
//    @ApiOperation(value = "通过ID批量删除电子发票明细表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
//    })
//    @DeleteMapping("/deleteByIds" )
//    public ResultRespone removeByIds(String ids) {
//        return ResultRespone.success(eiFpkjMxService.removeByIds(Arrays.asList(ids.split(","))));
//    }
}
