/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.dzfp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;


/**
 * 电子发票明细表
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "EI_FPKJ_MX", resultMap = "eiFpkjMxMap")
@KeySequence("EI_FPKJ_MX")
@ApiModel
public class EiFpkjMx extends Model<EiFpkjMx> {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId(value = "MXID", type = IdType.INPUT)
    @ApiModelProperty(value = "id")
    private String mxid;
    /**
     * 流水编号引用FPKJ_REQUEST.lsbh
     */
    @ApiModelProperty(value = "流水编号引用FPKJ_REQUEST.lsbh")
    private String lsbh;
    /**
     * 商品名称
     */
    @ApiModelProperty(value = "商品名称")
    private String goodsname;
    /**
     * 商品编码
     */
    @ApiModelProperty(value = "商品编码")
    private String goodscode;
    /**
     * 自行编码（可不填）
     */
    @ApiModelProperty(value = "自行编码（可不填）")
    private String selfcode;
    /**
     * 单价含税标志：0:不含税,1:含税
     */
    @ApiModelProperty(value = "单价含税标志：0:不含税,1:含税")
    private String withtaxflag;
    /**
     * 单价
     */
    @ApiModelProperty(value = "单价")
    private Double price;
    /**
     * 数量
     */
    @ApiModelProperty(value = "数量")
    private Double num;
    /**
     * 单位
     */
    @ApiModelProperty(value = "单位")
    private String unit;
    /**
     * 规格型号
     */
    @ApiModelProperty(value = "规格型号")
    private String spectype;
    /**
     * 税额，[不含税金额] * [税率] = [税额]；
     */
    @ApiModelProperty(value = "税额，[不含税金额] * [税率] = [税额]；")
    private Double tax;
    /**
     * 税率，
     */
    @ApiModelProperty(value = "税率，")
    private Double taxrate;
    /**
     * 不含税金额。红票为负
     */
    @ApiModelProperty(value = "不含税金额。红票为负")
    private Double taxexcludedamount;
    /**
     * 含税金额，[不含税金额] + [税额] = [含税金额]
     */
    @ApiModelProperty(value = "含税金额，[不含税金额] + [税额] = [含税金额]")
    private Double taxincludedamount;
    /**
     * 发票行性质：0,正常行;1,折扣行;2,被折扣行，红票只有正常行
     */
    @ApiModelProperty(value = "发票行性质：0,正常行;1,折扣行;2,被折扣行，红票只有正常行")
    private String invoicelineproperty;
    /**
     * 优惠政策标识：0,不使用;1,使用; 全电发票时： 01：简易征收 02：稀土产品 03：免税
     */
    @ApiModelProperty(value = "优惠政策标识：0,不使用;1,使用; 全电发票时： 01：简易征收 02：稀土产品 03：免税 ")
    private String favouredpolicyflag;
    /**
     * 值税特殊管理（优惠政策名称
     */
    @ApiModelProperty(value = "值税特殊管理（优惠政策名称")
    private String favouredpolicyname;
    /**
     * 扣除额
     */
    @ApiModelProperty(value = "扣除额")
    private Double deduction;
    /**
     * 零税率标识：空,非零税率;1,免税;2,不征税
     */
    @ApiModelProperty(value = "零税率标识：空,非零税率;1,免税;2,不征税")
    private String zerorateflag;
    /**
     * 序号
     */
    @ApiModelProperty(value = "序号")
    private BigDecimal xh;

}
