/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.dzfp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 电子发票汇总表
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "EI_FPKJ_REQUEST", resultMap = "eiFpkjRequestMap")
@KeySequence("EI_FPKJ_REQUEST")
@ApiModel
public class EiFpkjRequest extends Model<EiFpkjRequest> {
    private static final long serialVersionUID = 1L;

    /**
     * 处理结果0未1处理中2已处理
     */
    @ApiModelProperty(value = "处理结果0未1处理中2已处理")
    private String clCljg;
    /**
     * 处理时间
     */
    @ApiModelProperty(value = "处理时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date clClsj;
    /**
     * 处理返回代码
     */
    @ApiModelProperty(value = "处理返回代码")
    private String clRecode;
    /**
     * 处理返回信息
     */
    @ApiModelProperty(value = "处理返回信息")
    private String clRemessage;
    /**
     * 作废标志，0正常，1冲红，2被冲红
     */
    @ApiModelProperty(value = "作废标志，0正常，1冲红，2被冲红")
    private String zfZfbz;
    /**
     * 交付pdf
     */
    @ApiModelProperty(value = "交付pdf")
    private String jfPdf;
    /**
     * 交付pdf文件名称
     */
    @ApiModelProperty(value = "交付pdf文件名称")
    private String jfPdffilename;
    /**
     * 交付有效标志
     */
    @ApiModelProperty(value = "交付有效标志")
    private String jfYxbz;
    /**
     * 重新交付0不重新交付 1待重新交付，2已重新交付
     */
    @ApiModelProperty(value = "重新交付0不重新交付 1待重新交付，2已重新交付")
    private String cxJfbz;
    /**
     * 发票重开 1待重开，2已重开
     */
    @ApiModelProperty(value = "发票重开 1待重开，2已重开")
    private String fpCkbz;
    /**
     * 发票是否开票1开0否
     */
    @ApiModelProperty(value = "发票是否开票1开0否")
    private String fpSfkp;
    /**
     * 报装工程编号
     */
    @ApiModelProperty(value = "报装工程编号")
    private String bzGcbh;
    /**
     * 发票是否合并开票1是0否
     */
    @ApiModelProperty(value = "发票是否合并开票1是0否")
    private String fpSfHb;
    /**
     * 合并开票类型，1多笔欠费，2多用户欠费
     */
    @ApiModelProperty(value = "合并开票类型，1多笔欠费，2多用户欠费")
    private String fpHbLx;
    /**
     * 流水编号
     */
    @TableId(value = "LSBH", type = IdType.INPUT)
    @ApiModelProperty(value = "流水编号")
    private String lsbh;
    /**
     * 收费id
     */
    @ApiModelProperty(value = "收费id")
    private String sfid;
    /**
     * 收费流水编号，关于拆分收费明细
     */
    @ApiModelProperty(value = "收费流水编号，关于拆分收费明细")
    private String sfLsbh;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区")
    private String sspq;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号")
    private String cbkh;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    private String cwrq;
    /**
     * 实收金额
     */
    @ApiModelProperty(value = "实收金额")
    private Double ssje;
    /**
     * 收费类型
     */
    @ApiModelProperty(value = "收费类型")
    private String sflx;
    /**
     * 收费人员
     */
    @ApiModelProperty(value = "收费人员")
    private String sfry;
    /**
     * 收费日期
     */
    @ApiModelProperty(value = "收费日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date sfrq;
    /**
     * 购方名称
     */
    @ApiModelProperty(value = "购方名称")
    private String buyername;
    /**
     * 购方税号
     */
    @ApiModelProperty(value = "购方税号")
    private String buyertaxnum;
    /**
     * 购方电话
     */
    @ApiModelProperty(value = "购方电话")
    private String buyertel;
    /**
     * 购方地址
     */
    @ApiModelProperty(value = "购方地址")
    private String buyeraddress;
    /**
     * 购方银行开户行
     */
    @ApiModelProperty(value = "购方银行开户行")
    private String buyeraccount;
    /**
     * 购方银行账号
     */
    @ApiModelProperty(value = "购方银行账号")
    private String buyerbank;
    /**
     * 销方税号
     */
    @ApiModelProperty(value = "销方税号")
    private String salertaxnum;
    /**
     * 销方电话
     */
    @ApiModelProperty(value = "销方电话")
    private String salertel;
    /**
     * 销方地址
     */
    @ApiModelProperty(value = "销方地址")
    private String saleraddress;
    /**
     * 销方银行账号
     */
    @ApiModelProperty(value = "销方银行账号")
    private String saleraccount;
    /**
     * 销方银行开户行
     */
    @ApiModelProperty(value = "销方银行开户行")
    private String salerbank;
    /**
     * 订单号（每个企业唯一）
     */
    @ApiModelProperty(value = "订单号（每个企业唯一）")
    private String orderno;
    /**
     * 订单时间
     */
    @ApiModelProperty(value = "订单时间")
    private String invoicedate;
    /**
     * 发票代码
     */
    @ApiModelProperty(value = "发票代码")
    private String invoicecode;
    /**
     * 冲红时填写的对应蓝票发票代码（红票必填 10位或12 位， 11位的时候请左补 0）
     */
    @ApiModelProperty(value = "冲红时填写的对应蓝票发票代码（红票必填 10位或12 位， 11位的时候请左补 0）")
    private String invoicenum;
    /**
     * 冲红原因：1:销货退回;2:开票有误;3:服务中止;4:发生销售折让
     */
    @ApiModelProperty(value = "冲红原因：1:销货退回;2:开票有误;3:服务中止;4:发生销售折让")
    private String redreason;
    /**
     * 红字信息表编号.专票冲红时此项必填，且必须在备注中注明“开具红字增值税专用
     */
    @ApiModelProperty(value = "红字信息表编号.专票冲红时此项必填，且必须在备注中注明“开具红字增值税专用")
    private String billinfono;
    /**
     * 部门门店id（诺诺系统中的id）
     */
    @ApiModelProperty(value = "部门门店id（诺诺系统中的id）")
    private String departmentid;
    /**
     * 开票员id（诺诺系统中的id）
     */
    @ApiModelProperty(value = "开票员id（诺诺系统中的id）")
    private String clerkid;
    /**
     * 冲红时，在备注中注明
     */
    @ApiModelProperty(value = "冲红时，在备注中注明")
    private String remark;
    /**
     * 不含税金额
     */
    @ApiModelProperty(value = "不含税金额 ")
    private Double extaxamount;
    /**
     * 合计税额
     */
    @ApiModelProperty(value = "合计税额")
    private Double taxamount;
    /**
     * 价税合计
     */
    @ApiModelProperty(value = "价税合计 ")
    private Double orderamount;
    /**
     * 复核人
     */
    @ApiModelProperty(value = "复核人")
    private String checker;
    /**
     * 收款人
     */
    @ApiModelProperty(value = "收款人")
    private String payee;
    /**
     * 开票员
     */
    @ApiModelProperty(value = "开票员")
    private String clerk;
    /**
     * 清单标志：非清单:0；清单:1，默认:0，电票固定为0
     */
    @ApiModelProperty(value = "清单标志：非清单:0；清单:1，默认:0，电票固定为0")
    private String listflag;
    /**
     * 清单项目名称：对应发票票面项目名称（listFlag为1时，必填，默认为“详见销货清单”）
     */
    @ApiModelProperty(value = "清单项目名称：对应发票票面项目名称（listFlag为1时，必填，默认为“详见销货清单”）")
    private String listname;
    /**
     * 推送方式：-1,不推送;0,邮箱;1,手机（默认）;2,邮箱、手机
     */
    @ApiModelProperty(value = "推送方式：-1,不推送;0,邮箱;1,手机（默认）;2,邮箱、手机")
    private String pushmode;
    /**
     * 购方手机（pushMode为1或2时，此项为必填，同时受企业资质是否必填控制）
     */
    @ApiModelProperty(value = "购方手机（pushMode为1或2时，此项为必填，同时受企业资质是否必填控制）")
    private String buyerphone;
    /**
     * 推送邮箱（pushMode为0或2时，此项为必填，同时受企业资质是否必填控制）
     */
    @ApiModelProperty(value = "推送邮箱（pushMode为0或2时，此项为必填，同时受企业资质是否必填控制）")
    private String email;
    /**
     * 开票类型：1:蓝票;2:红票
     */
    @ApiModelProperty(value = "开票类型：1:蓝票;2:红票 ")
    private String invoicetype;
    /**
     * 发票种类p,普通发票(电票)(默认);c,普通
     发票(纸票);s,专用发票;e,收购发票(电票);f,
     收购发票(纸质);r,普通发票(卷式);b,增值税
     电子专用发票;j,机动车销售统一发票;u,二手
     车销售统一发票;bs:电子发票(增值税专用
     发票)-即全电专票,pc:电子发票(普通发票)-
     即全电普票
     */
    @ApiModelProperty(value = "发票种类p,普通发票(电票)(默认);c,普通")
    private String invoiceline;
    /**
     * 特定要素：0普通发票（默认） 、 1成品油
     、 31建安发票 、 32房地产销售发票
     */
    @ApiModelProperty(value = "特定要素：0普通发票（默认） 、 1成品油、 31建安发票 、 32房地产销售发票")
            private String specificfactor;
            /**
             * 代开标志：0非代开;1代开
            */
            @ApiModelProperty(value = "代开标志：0非代开;1代开")
            private String proxyinvoiceflag;
            /**
             * 发票流水号  开票返回参数
            */
            @ApiModelProperty(value = "发票流水号  开票返回参数")
            private String invoiceserialnum;
            /**
             * 开票时间
            */
            @ApiModelProperty(value = "开票时间")
            private String invoicetime;
            /**
             * 发票状态： 2 :开票完成（ 最终状 态），其他状态分别为: 20:开票中; 21:开票成功签章中;22:开票失败;24: 开票成功签章失败;3:发票已作废 31: 发票作废中 备注：22、24状态时，无需再查询，请确认开票失败原因以及签章失败原因； 注：请以该状态码区分发票状态
            */
            @ApiModelProperty(value = "发票状态： 2 :开票完成（ 最终状 态），其他状态分别为: 20:开票中; 21:开票成功签章中;22:开票失败;24: 开票成功签章失败;3:发票已作废 31: 发票作废中 备注：22、24状态时，无需再查询，请确认开票失败原因以及签章失败原因； 注：请以该状态码区分发票状态")
            private String status;
            /**
             * 发票状态描述
            */
            @ApiModelProperty(value = "发票状态描述")
            private String statusmsg;
            /**
             * 失败原因
            */
            @ApiModelProperty(value = "失败原因")
            private String failcause;
            /**
             * 发票pdf地址（若同时返回了ofdUrl与pdfUrl，则pdf文件不能做为原始凭证，请用ofd文件做为原始凭证）
            */
            @ApiModelProperty(value = "发票pdf地址（若同时返回了ofdUrl与pdfUrl，则pdf文件不能做为原始凭证，请用ofd文件做为原始凭证）")
            private String pdfurl;
            /**
             * 是否锁定1是0否
            */
            @ApiModelProperty(value = "是否锁定1是0否")
            private String clLock;
}
