/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.dzfp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 电子发票销售方配置信息
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "EI_SALER_CONFIG", resultMap = "eiSalerConfigMap")
@KeySequence("EI_SALER_CONFIG")
@ApiModel
public class EiSalerConfig extends Model<EiSalerConfig> {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * 销方开户行及账户
     */
    @ApiModelProperty(value = "销方账户")
    private String saleraccount;
    /**
     * 销方开户行及账户
     */
    @ApiModelProperty(value = "销方开户行")
    private String salerbank;
    /**
     * 销方地址
     */
    @ApiModelProperty(value = "销方地址")
    private String saleraddress;
    /**
     * 销方电话
     */
    @ApiModelProperty(value = "销方电话")
    private String salertel;
    /**
     * 授权企业税号
     */
    @ApiModelProperty(value = "授权企业税号")
    private String salertaxnum;
    /**
     * 部门门店id
     */
    @ApiModelProperty(value = "部门门店id")
    private String departmentid;
    /**
     * 开票员id
     */
    @ApiModelProperty(value = "开票员id")
    private String clerkid;
    /**
     * 分机号
     */
    @ApiModelProperty(value = "分机号")
    private String extensionnumber;
    /**
     * 终端号
     */
    @ApiModelProperty(value = "终端号")
    private String terminalnumber;
    /**
     * 机器编号
     */
    @ApiModelProperty(value = "机器编号")
    private String machinecode;
    /**
     * 片区编码
     */
    @ApiModelProperty(value = "片区编码")
    private String pqbm;
    /**
     * 公司编码
     */
    @ApiModelProperty(value = "公司编码")
    private String gsbm;
    /**
     * 启用1关闭0
     */
    @ApiModelProperty(value = "启用1关闭0")
    private String disable;

}
