/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.dzfp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 电子发票-商品编码
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "EI_SPBM", resultMap = "eiSpbmMap")
@KeySequence("EI_SPBM")
@ApiModel
public class EiSpbm extends Model<EiSpbm> {
    private static final long serialVersionUID = 1L;

    /**
     * 编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "编码")
    private String code;
    /**
     * 商品名称
     */
    @ApiModelProperty(value = "商品名称")
    private String goodname;
    /**
     * 商品编码
     */
    @ApiModelProperty(value = "商品编码")
    private String goodcode;
    /**
     * 商品简称
     */
    @ApiModelProperty(value = "商品简称")
    private String goodnameShort;
    /**
     * 税率
     */
    @ApiModelProperty(value = "税率")
    private String taxrate;
    /**
     * 单位
     */
    @ApiModelProperty(value = "单位")
    private String unit;
    /**
     * 单价含税标识1含税单价0不含税单价
     */
    @ApiModelProperty(value = "单价含税标识1含税单价0不含税单价")
    private String withtaxflag;
    /**
     * 零税率标识：空,非零税率;1,免税;2,不征税;3,普通零税率；
     */
    @ApiModelProperty(value = "零税率标识：空,非零税率;1,免税;2,不征税;3,普通零税率；")
    private String zerorateflag;
    /**
     * 优惠政策标识：0,不使用;1,使用; 全电发票
     * 时： 01：简易征收 02：稀土产品 03：免
     * 税
     */
    @ApiModelProperty(value = "优惠政策标识：0,不使用;1,使用; 全电发票 时： 01：简易征收 02：稀土产品 03：免 税 ")
    private String favouredpolicyflag;
    /**
     * 优惠政策名称增值税特殊管理（优惠政策名称）,当favo
     * uredPolicyFlag为1时，此项必填 （全电
     * 发票时为空）
     */
    @ApiModelProperty(value = "优惠政策名称增值税特殊管理（优惠政策名称）,当favo uredPolicyFlag为1时，此项必填 （全电 发票时为空）")
    private String favouredpolicyname;
    /**
     * 启用1，0关闭
     */
    @ApiModelProperty(value = "启用1，0关闭")
    private String disable;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String czryBm;
    /**
     * 操作人员名称
     */
    @ApiModelProperty(value = "操作人员名称")
    private String czryMc;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;

}
