package com.tofly.feesapi.dzfp.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.entity.dto.SortDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@ApiModel("数电发票汇总明细查询参数DTO")
public class EiFpkjRequestFilter extends SortDto {


    @ApiModelProperty(value = "所属公司编码")
    private String ssgs;

    @ApiModelProperty(value = "所属片区编码")
    private String sspq;

    @ApiModelProperty("关键字(用户编号、购方名称、购方地址、购方电话、购方手机、开票码、开票号码、财务月份)")
    private String searchText;
    /**
     * 开票类型
     */
    @ApiModelProperty(value = "开票类型")
    private String invoiceType;
    /**
     * 是否开票
     */
    @ApiModelProperty(value = "是否开票")
    private String fp_sfkp;
    /**
     * 发票种类
     */
    @ApiModelProperty(value = "发票种类")
    private String invoiceLine;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    private String cwrq;
    /**
     * 开票状态
     */
    @ApiModelProperty(value = "开票状态")
    private String status;

    /**
     * 收费类型
     */
    @ApiModelProperty(value = "收费类型")
    private String sflx;
    /**
     * 收费人员
     */
    @ApiModelProperty(value = "收费人员")
    private String sfry;

    @ApiModelProperty(value = "开票类型：1:蓝票;2:红票 ")
    private String invoicetype;

    @ApiModelProperty(value = "统计时间类型：1:收费时间;2:开票时间 ")
    private String tjsj_type;
    /**
     * 收费日期
     */
    @ApiModelProperty(value = "统计时间开始")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date start_tjsj;
    @ApiModelProperty(value = "统计时间结束")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date end_tjsj;



}
