package com.tofly.feesapi.dzfp.entity.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class EiFpkjRequest_Excel {

    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @ExcelProperty("用户编号")
    private String yhbh;

    /**
     * 购方名称
     */
    @ApiModelProperty(value = "购方名称")
    @ExcelProperty("购方名称")
    private String buyername;
    /**
     * 实收金额
     */
    @ApiModelProperty(value = "实收金额")
    @ExcelProperty("实收金额")
    private Double ssje;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    @ExcelProperty("财务日期")
    private String cwrq;

    /**
     * 收费人员
     */
    @ApiModelProperty(value = "收费人员")
    @ExcelProperty("收费人员")
    private String sfry;
    /**
     * 收费日期
     */
    @ApiModelProperty(value = "收费日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("收费日期")
    private Date sfrq;

    /**
     * 不含税金额
     */
    @ApiModelProperty(value = "不含税金额 ")
    @ExcelProperty("不含税金额")
    private Double extaxamount;
    /**
     * 合计税额
     */
    @ApiModelProperty(value = "合计税额")
    @ExcelProperty("合计税额")
    private Double taxamount;
    /**
     * 价税合计
     */
    @ApiModelProperty(value = "价税合计 ")
    @ExcelProperty("价税合计")
    private Double orderamount;


    /**
     * 发票代码
     */
    @ApiModelProperty(value = "发票代码")
    @ExcelProperty("发票代码")
    private String invoicecode;
    /**
     * 冲红时填写的对应蓝票发票代码（红票必填 10位或12 位， 11位的时候请左补 0）
     */
    @ApiModelProperty(value = "冲红时填写的对应蓝票发票代码（红票必填 10位或12 位， 11位的时候请左补 0）")
    @ExcelProperty("发票号码")
    private String invoicenum;


    @ApiModelProperty(value = "冲红时，在备注中注明")
    @ExcelProperty("发票备注")
    private String remark;



    /**
     * 推送方式：-1,不推送;0,邮箱;1,手机（默认）;2,邮箱、手机
     */
    @ApiModelProperty(value = "推送方式：-1,不推送;0,邮箱;1,手机（默认）;2,邮箱、手机")
    @ExcelProperty("推送方式")
    private String pushmode;

    /**
     * 开票类型：1:蓝票;2:红票
     */
    @ApiModelProperty(value = "开票类型：1:蓝票;2:红票 ")
    @ExcelProperty("开票类型")
    private String invoicetype;
    /**
     * 发票种类p,普通发票(电票)(默认);c,普通
     发票(纸票);s,专用发票;e,收购发票(电票);f,
     收购发票(纸质);r,普通发票(卷式);b,增值税
     电子专用发票;j,机动车销售统一发票;u,二手
     车销售统一发票;bs:电子发票(增值税专用
     发票)-即全电专票,pc:电子发票(普通发票)-
     即全电普票
     */
    @ApiModelProperty(value = "发票种类p,普通发票(电票)(默认);c,普通")
    @ExcelProperty("发票种类")
    private String invoiceline;


    /**
     * 开票时间
     */
    @ApiModelProperty(value = "开票时间")
    @ExcelProperty("开票时间")
    private String invoicetime;
    /**
     * 发票状态： 2 :开票完成（ 最终状 态），其他状态分别为: 20:开票中; 21:开票成功签章中;22:开票失败;24: 开票成功签章失败;3:发票已作废 31: 发票作废中 备注：22、24状态时，无需再查询，请确认开票失败原因以及签章失败原因； 注：请以该状态码区分发票状态
     */
    @ApiModelProperty(value = "发票状态： 2 :开票完成（ 最终状 态），其他状态分别为: 20:开票中; 21:开票成功签章中;22:开票失败;24: 开票成功签章失败;3:发票已作废 31: 发票作废中 备注：22、24状态时，无需再查询，请确认开票失败原因以及签章失败原因； 注：请以该状态码区分发票状态")
    @ExcelProperty("发票状态")
    private String status;


    /**
     * 作废标志，0正常，1冲红，2被冲红
     */
    @ApiModelProperty(value = "作废标志，0正常，1冲红，2被冲红")
    @ExcelProperty("作废标志")
    private String zfZfbz;

    /**
     * 交付有效标志
     */
    @ApiModelProperty(value = "交付有效标志")
    @ExcelProperty("交付有效标志")
    private String jfYxbz;


    /**
     * 发票是否开票1开0否
     */
    @ApiModelProperty(value = "发票是否开票1开0否")
    @ExcelProperty("发票是否开票")
    private String fpSfkp;


}
