package com.tofly.feesapi.dzfp.entity.dto;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
@ApiModel
public class EiFpkjRequest_select {
    @ExcelIgnore
    @ApiModelProperty(value = "收费id")
    private String sfid;

    @ApiModelProperty(value = "流水编号关于开票明细")
    private String lsbh;
    @ExcelIgnore
    @ApiModelProperty(value = "公司")
    private String ssgs;

    @ExcelIgnore
    @ApiModelProperty(value = "片区")
    private String sspq;

    @ColumnWidth(20)
    @ExcelProperty("用户编号")
    @ApiModelProperty(value = "用户编号")
    private String yhbh;

    @ColumnWidth(20)
    @ExcelProperty("购方名称")
    @ApiModelProperty(value = "购方名称")
    private String buyerName;

    @ColumnWidth(20)
    @ExcelProperty("实收金额")
    @ApiModelProperty(value = "实收金额")
    private String ssje;

    @ColumnWidth(20)
    @ApiModelProperty(value = "财务日期")
    @ExcelProperty("财务日期")
    private String cwrq;

    @ColumnWidth(20)
    @ExcelProperty("收费日期")
    @ApiModelProperty(value = "收费日期")
    private String sfrq;

    @ColumnWidth(20)
    @ExcelProperty("开票日期")
    @ApiModelProperty(value = "开票日期")
    private String invoicetime;

    @ColumnWidth(20)
    @ExcelProperty("收费人员")
    @ApiModelProperty(value = "收费人员")
    private String sfry;

    @ExcelIgnore
    @ApiModelProperty(value = "推送方式编码")
    private String pushMode;

    @ColumnWidth(20)
    @ExcelProperty("推送方式")
    @ApiModelProperty(value = "推送方式名称")
    private String pushModeMc;

    @ColumnWidth(20)
    @ExcelProperty("不含税金额")
    @ApiModelProperty(value = "不含税金额")
    private String exTaxAmount;

    @ColumnWidth(20)
    @ExcelProperty("税额")
    @ApiModelProperty(value = "税额")
    private String taxAmount;

    @ColumnWidth(20)
    @ExcelProperty("含税金额")
    @ApiModelProperty(value = "含税金额")
    private String orderAmount;

    @ExcelIgnore
    @ApiModelProperty(value = "开票类型编码")
    private String invoiceType;

    @ColumnWidth(20)
    @ExcelProperty("开票类型")
    @ApiModelProperty(value = "开票类型名称")
    private String invoiceTypeMc;

    @ExcelIgnore
    @ApiModelProperty(value = "发票类型编码")
    private String invoiceLine;

    @ColumnWidth(20)
    @ExcelProperty("发票类型")
    @ApiModelProperty(value = "发票类型名称")
    private String invoiceLineMc;

    @ExcelIgnore
    @ApiModelProperty(value = "是否交付编码")
    private String jf_yxbz;

    @ColumnWidth(20)
    @ExcelProperty("是否交付")
    @ApiModelProperty(value = "是否交付名称")
    private String jf_yxbzMc;

    @ExcelIgnore
    @ApiModelProperty(value = "发票状态编码")
    private String status;

    @ColumnWidth(20)
    @ExcelProperty("发票状态")
    @ApiModelProperty(value = "发票状态名称")
    private String statusMc;

    @ColumnWidth(20)
    @ExcelProperty("发票号码")
    @ApiModelProperty(value = "发票号码")
    private String invoiceNum;

    @ExcelIgnore
    @ApiModelProperty(value = "发票作废标志编码")
    private String zf_zfbz;

    @ColumnWidth(20)
    @ExcelProperty("发票作废标志名称")
    @ApiModelProperty(value = "发票作废名称")
    private String zf_zfbzMc;

    @ExcelIgnore
    @ApiModelProperty(value = "是否开票编码")
    private String fp_sfkp;

    @ColumnWidth(20)
    @ExcelProperty("是否开票")
    @ApiModelProperty(value = "是否开票名称")
    private String fp_sfkpMc;

    @ExcelIgnore
    @ApiModelProperty(value = "是否合并开票编码")
    private String fp_sf_hb;

    @ColumnWidth(20)
    @ApiModelProperty(value = "是否合并开票名称")
    @ExcelProperty("是否合并开票")
    private String fp_sf_hbMc;

    @ExcelIgnore
    @ApiModelProperty(value = "发票失败原因编码")
    private String fp_hb_lx;

    @ExcelProperty("发票失败原因")
    @ApiModelProperty(value = "发票失败原因名称")
    private String fp_hb_lxMc;

    @ColumnWidth(20)
    @ExcelProperty("发票状态原因")
    @ApiModelProperty(value = "发票状态原因")
    private String statusmsg;

    @ColumnWidth(20)
    @ExcelProperty("发票失败原因")
    @ApiModelProperty(value = "发票失败原因")
    private String failcause;

}
