/*
 * Author: wangjian
 * 生成ServiceImpl
 */
package com.tofly.feesapi.dzfp.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.common.entity.dto.Order;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.dzfp.entity.EiFpkjMx;
import com.tofly.feesapi.dzfp.entity.EiFpkjRequest;
import com.tofly.feesapi.dzfp.entity.dto.EiFpkjRequestFilter;
import com.tofly.feesapi.dzfp.entity.dto.EiFpkjRequest_select;
import com.tofly.feesapi.dzfp.entity.dto.EiFpkjRequest_sum;
import com.tofly.feesapi.dzfp.mapper.EiFpkjRequestMapper;
import com.tofly.feesapi.dzfp.service.EiFpkjMxService;
import com.tofly.feesapi.dzfp.service.EiFpkjRequestService;
import com.tofly.feesapi.security.model.CzyUserDetails;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 电子发票汇总表
 *
 * @author sxb
 * @date Thu Jul 18 00:00:00 CST 2024
 */
@Service("eiFpkjRequestService")
public class EiFpkjRequestServiceImpl extends ServiceImpl<EiFpkjRequestMapper, EiFpkjRequest> implements EiFpkjRequestService {

//    @Override
//    public List<EiFpkjRequest_Excel> getList(EiFpkjRequest eiFpkjRequest) {
//        List<EiFpkjRequest_Excel> list = this.baseMapper.getList(filter);
//        return list;
//    }

    @Autowired
    private EiFpkjMxService eiFpkjMxService;

    @Autowired
    private EiFpkjRequestService eiFpkjRequestService;

    @Override
    public PageResult<EiFpkjRequest_select> getPage(PageDto pageDto, EiFpkjRequestFilter filter) {
        List<Order> orders = pageDto.getOrders();
        orders = orders.stream().map(item -> {
            Order order = new Order();
          //  if (item.getColumn().equals("yhbh")) {
                order.setColumn("sfrq");
           // }
            order.setAsc(item.isAsc());
            return order;
        }).collect(Collectors.toList());
        pageDto.setOrders(orders);
        PageDto<EiFpkjRequest_select> page = this.baseMapper.getPage(pageDto, filter);
        return page.toVo();
    }

    @Override
    public PageResult<EiFpkjRequest_select> getSfPage(PageDto pageDto, EiFpkjRequestFilter filter) {
        List<Order> orders = pageDto.getOrders();
        orders = orders.stream().map(item -> {
            Order order = new Order();
            //  if (item.getColumn().equals("yhbh")) {
            order.setColumn("sfrq");
            // }
            order.setAsc(item.isAsc());
            return order;
        }).collect(Collectors.toList());
        pageDto.setOrders(orders);
        PageDto<EiFpkjRequest_select> page = this.baseMapper.getSfPage(pageDto, filter);
        return page.toVo();
    }
    @Override
    public PageResult<EiFpkjRequest_select> getFpPage(PageDto pageDto, EiFpkjRequestFilter filter) {
        List<Order> orders = pageDto.getOrders();
        orders = orders.stream().map(item -> {
            Order order = new Order();
            //  if (item.getColumn().equals("yhbh")) {
            order.setColumn("sfrq");
            // }
            order.setAsc(item.isAsc());
            return order;
        }).collect(Collectors.toList());
        pageDto.setOrders(orders);
        PageDto<EiFpkjRequest_select> page = this.baseMapper.getFpPage(pageDto, filter);
        return page.toVo();
    }
    @Override
    public PageResult<EiFpkjRequest_select> getWsfPage(PageDto pageDto, EiFpkjRequestFilter filter) {
        List<Order> orders = pageDto.getOrders();
        orders = orders.stream().map(item -> {
            Order order = new Order();
            //  if (item.getColumn().equals("yhbh")) {
            order.setColumn("sfrq");
            // }
            order.setAsc(item.isAsc());
            return order;
        }).collect(Collectors.toList());
        pageDto.setOrders(orders);
        PageDto<EiFpkjRequest_select> page = this.baseMapper.getWsfPage(pageDto, filter);
        return page.toVo();
    }
    @Override
    public PageResult<EiFpkjRequest_select> getZnjPage(PageDto pageDto, EiFpkjRequestFilter filter) {
        List<Order> orders = pageDto.getOrders();
        orders = orders.stream().map(item -> {
            Order order = new Order();
            //  if (item.getColumn().equals("yhbh")) {
            order.setColumn("sfrq");
            // }
            order.setAsc(item.isAsc());
            return order;
        }).collect(Collectors.toList());
        pageDto.setOrders(orders);
        PageDto<EiFpkjRequest_select> page = this.baseMapper.getZnjPage(pageDto, filter);
        return page.toVo();
    }
    @Override
    public List<EiFpkjRequest_select> getList(EiFpkjRequestFilter filter) {
        List<EiFpkjRequest_select> list = this.baseMapper.getList(filter);
        return list;
    }

    @Override
    public List<EiFpkjRequest_sum> getListSum(EiFpkjRequestFilter filter) {
        List<EiFpkjRequest_sum> list = this.baseMapper.getListSum(filter);
        return list;
    }

    @Override
    public boolean dzfpch(EiFpkjRequest eiFpkjRequest, CzyUserDetails czyUserDetails) {
        boolean result=false;
        EiFpkjRequest eiFpkjRequest_ch=new EiFpkjRequest();//冲红
            //查询发票明细信息
        EiFpkjMx eiFpkjMx = eiFpkjMxService.getById(eiFpkjRequest.getSfid());
        //1.添加汇总作废票据信息
        BeanUtils.copyProperties(eiFpkjRequest,eiFpkjRequest_ch);
        eiFpkjRequest_ch.setLsbh(GuidGenerator.getGuid());
        eiFpkjRequest_ch.setSfid(GuidGenerator.getGuid());
         if(eiFpkjRequest_ch.getSsje()>0)
         {
             eiFpkjRequest_ch.setSsje(-eiFpkjRequest_ch.getSsje());//实收金额
         }
         if(eiFpkjRequest_ch.getExtaxamount()>0)
         {
             eiFpkjRequest_ch.setExtaxamount(-eiFpkjRequest_ch.getExtaxamount());//不含税金额
         }
        if(eiFpkjRequest_ch.getTaxamount()>0)
        {
            eiFpkjRequest_ch.setTaxamount(-eiFpkjRequest_ch.getTaxamount());//合计税额
        }
        if(eiFpkjRequest_ch.getOrderamount()>0)
        {
            eiFpkjRequest_ch.setOrderamount(-eiFpkjRequest_ch.getOrderamount());//价税合计
        }
        eiFpkjRequest_ch.setZfZfbz("2");
        eiFpkjRequest_ch.setStatus("0");
        eiFpkjRequest_ch.setClLock("0");
        eiFpkjRequest_ch.setClCljg("0");
        eiFpkjRequest_ch.setJfYxbz("0");
        eiFpkjRequest_ch.setRemark("对应正数发票代码:" + eiFpkjRequest.getInvoicecode() + "号码:" + eiFpkjRequest.getInvoicenum()); //备注
        result= eiFpkjRequestService.save(eiFpkjRequest_ch);//1.添加汇总发票信息
        eiFpkjRequest.setZfZfbz("1");
        result= eiFpkjRequestService.updateById(eiFpkjRequest); //2.修改汇总发票信息

        EiFpkjMx eiFpkjMx_ch=new EiFpkjMx();//冲红明细
        //添加开票作废明细信息
        List<EiFpkjMx> eiFpkjMxList=eiFpkjMxService.lambdaQuery().eq(EiFpkjMx::getLsbh,eiFpkjRequest.getSfid()).list();
        //
        for (EiFpkjMx e : eiFpkjMxList) {
            eiFpkjMx_ch.setMxid(GuidGenerator.getGuid());
            eiFpkjMx_ch.setLsbh(eiFpkjRequest_ch.getSfid());
            eiFpkjMx_ch.setGoodsname(e.getGoodsname());//商品名称
            eiFpkjMx_ch.setGoodscode(e.getGoodscode());//商品编码
            eiFpkjMx_ch.setSpectype(e.getSpectype());//规格型号
            eiFpkjMx_ch.setSelfcode(e.getSelfcode());//自行编码
            eiFpkjMx_ch.setWithtaxflag(e.getWithtaxflag());//单价含税标识
            eiFpkjMx_ch.setInvoicelineproperty(e.getInvoicelineproperty());//发票性质
            eiFpkjMx_ch.setFavouredpolicyname(e.getFavouredpolicyname());//优惠政策名称
            eiFpkjMx_ch.setFavouredpolicyflag(e.getFavouredpolicyflag());//优惠政策标识
            eiFpkjMx_ch.setDeduction(e.getDeduction());//扣除金额
            eiFpkjMx_ch.setZerorateflag(e.getZerorateflag());//零税率标识

            eiFpkjMx_ch.setXh(e.getXh());//序号
            eiFpkjMx_ch.setUnit(e.getUnit());//单位
            eiFpkjMx_ch.setPrice(e.getPrice());//单价
            if(e.getNum()>0)
            {
                eiFpkjMx_ch.setNum(-e.getNum());//数量
            }
            if(e.getTax()>0)
            {
                eiFpkjMx_ch.setTax(-e.getTax());//税额
            }
            if(e.getTax()>0)
            {
                eiFpkjMx_ch.setTax(-e.getTax());//税额
            }
            eiFpkjMx_ch.setTaxrate(e.getTaxrate());//税率
            if(e.getTaxexcludedamount()>0)
            {
                eiFpkjMx_ch.setTaxexcludedamount(-e.getTaxexcludedamount());//不含税金额
            }
            if(e.getTaxincludedamount()>0)
            {
                eiFpkjMx_ch.setTaxincludedamount(-e.getTaxincludedamount());//含税金额
            }
            result=  eiFpkjMxService.save(eiFpkjMx_ch);//添加冲红发票明细

        }
        //3.添加发票明细信息
        return result;
    }
}
