/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.sms.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 短信消息
 *
 * @author sunjian
 * @date Fri Nov 08 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "SMS_MESSAGE", resultMap = "smsMessageMap")
@KeySequence("SMS_MESSAGE")
@ApiModel("短信消息Vo")
public class SmsMessage extends Model<SmsMessage> {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * 流水号
     */
    @ApiModelProperty(value = "流水号")
    private String lsh;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 财务月份
     */
    @ApiModelProperty(value = "财务月份")
    private String cwyf;
    /**
     * 上次底数
     */
    @ApiModelProperty(value = "上次底数")
    private BigDecimal scds;
    /**
     * 本次底数
     */
    @ApiModelProperty(value = "本次底数")
    private BigDecimal bcds;
    /**
     * 提醒类型
     */
    @ApiModelProperty(value = "提醒类型")
    private String txlx;
    /**
     * 提醒内容
     */
    @ApiModelProperty(value = "提醒内容")
    private String txnr;
    /**
     * 添加时间
     */
    @ApiModelProperty(value = "添加时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date scsj;
    /**
     * 发送状态(0=待发,1=成功,2=失败)
     */
    @ApiModelProperty(value = "发送状态(0=待发,1=成功,2=失败)")
    private String fszt;
    /**
     * 处理人员编号
     */
    @ApiModelProperty(value = "处理人员编号")
    private String clry;
    /**
     * 处理时间
     */
    @ApiModelProperty(value = "处理时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date clsj;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 锁定标志（0 未锁定，1 已锁定）
     */
    @ApiModelProperty(value = "锁定标志（0 未锁定，1 已锁定）")
    private String sLock;
    /**
     * 应收水量
     */
    @ApiModelProperty(value = "应收水量")
    private BigDecimal yssl;
    /**
     * 应收水费
     */
    @ApiModelProperty(value = "应收水费")
    private BigDecimal yssf;
    /**
     * 应收污水费
     */
    @ApiModelProperty(value = "应收污水费")
    private BigDecimal yswsf;
    /**
     * 欠费金额
     */
    @ApiModelProperty(value = "欠费金额")
    private BigDecimal qfje;
    /**
     * 欠费月份
     */
    @ApiModelProperty(value = "欠费月份")
    private BigDecimal yf;
    /**
     * 总欠费
     */
    @ApiModelProperty(value = "总欠费")
    private Double zje;
    /**
     * 补发次数
     */
    @ApiModelProperty(value = "补发次数")
    private BigDecimal count;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "操作人员编码")
    private String czrybm;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String czryxm;
    /**
     * 剩余金额
     */
    @ApiModelProperty(value = "剩余金额")
    private BigDecimal syje;

}
