package com.tofly.feesapi.sms.entity.dto;

import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 短信消息Dto
 *
 * @author sunjian
 * @date Fri Nov 08 00:00:00 CST 2024
 */
@Data
@ApiModel
public class SmsMessageDto extends Model<SmsMessageDto> {
    private static final long serialVersionUID = 1L;

    /**
     * 流水号
     */
    @ApiModelProperty(value = "流水号")
    private String lsh;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 提醒类型
     */
    @ApiModelProperty(value = "提醒类型")
    private String txlx;

    /**
     * 添加时间
     */
    @ApiModelProperty(value = "添加时间-开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date scsj_s;
    /**
     * 添加时间
     */
    @ApiModelProperty(value = "添加时间-结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date scsj_e;
    /**
     * 添加时间
     */
    @ApiModelProperty(value = "发送时间-开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date clsj_s;
    /**
     * 添加时间
     */
    @ApiModelProperty(value = "发送时间-结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date clsj_e;
    /**
     * 发送状态(0=待发,1=成功,2=失败)
     */
    @ApiModelProperty(value = "发送状态(0=待发,1=成功,2=失败)")
    private String fszt;

    /**
     * 关键字(用户编号、用户姓名、用户地址)
     */
    @ApiModelProperty(value = "关键字(用户编号、用户姓名、用户地址)")
    private String searchText;
}
