package com.tofly.feesapi.sms.entity.vo;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 短信消息vo
 *
 * @author sunjian
 * @date Fri Nov 08 00:00:00 CST 2024
 */
@Data
@ApiModel
public class SmsMessageVo extends Model<SmsMessageVo> {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 提醒类型
     */
    @ApiModelProperty(value = "提醒类型")
    private String txlx;
    /**
     * 提醒类型
     */
    @ApiModelProperty(value = "提醒类型名称")
    private String txlxName;
    /**
     * 添加时间
     */
    @ApiModelProperty(value = "添加时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date scsj;
    /**
     * 发送状态(0=待发,1=成功,2=失败)
     */
    @ApiModelProperty(value = "发送状态(0=待发,1=成功,2=失败)")
    private String fszt;
    /**
     * 发送状态(0=待发,1=成功,2=失败)
     */
    @ApiModelProperty(value = "发送状态(0=待发,1=成功,2=失败)")
    private String fsztName;
    /**
     * 发送时间
     */
    @ApiModelProperty(value = "发送时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date clsj;

}
