/*
 * Author: wangjian
 * 生成Service
 */
package com.tofly.feesapi.sms.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.sms.entity.SmsMessage;
import com.tofly.feesapi.sms.entity.dto.SmsMessageDto;
import com.tofly.feesapi.sms.entity.dto.SmsMessageYhxxDto;
import com.tofly.feesapi.sms.entity.vo.SmsMessageVo;
import com.tofly.feesapi.sms.entity.vo.SmsMessageYhxxVo;

/**
 * 短信消息
 *
 * @author sunjian
 * @date Fri Nov 08 00:00:00 CST 2024
 */
public interface ISmsMessageService extends IService<SmsMessage> {
    /**
     * 自定义分页查询
     *
     * @param page
     * @param smsmessageDto
     * @return
     */
    Page<SmsMessage> getSmsMessagePage(Page page, SmsMessageDto smsmessageDto);

    /**
     * 批量更新发送状态 重新发送
     * @param ids
     * @return
     */
    ResultRespone<Object> reSendByIds(String ids);

    /**
     * 自定义短信发送
     * @param phone 电话号码
     * @param content 短信内容
     * @return
     */
    ResultRespone<Object> customizeSendMessage(String phone, String content, CzyUserDetails czyUserDetails);

    /**
     * 获取短信信息用户列表
     * @param page
     * @param dto
     * @return
     */
    Page<SmsMessageYhxxVo> getSmsMessageYhxxVoList(Page page, SmsMessageYhxxDto dto);

    /**
     * 获取短信信息用户列表(包含欠费)
     * @param page
     * @param dto
     * @return
     */
    Page<SmsMessageYhxxVo> getSmsMessageYhqfxxVoList(Page page, SmsMessageYhxxDto dto);

    /**
     * 批量发送自定义短信
     * @param dxnr 短信内容
     * @param dto  条件参数(按照勾选发送，需要传入yhbhs)
     * @return
     */
    ResultRespone<Object> batchSendMessageYhxx(String dxnr, SmsMessageYhxxDto dto);

    /**
     * 批量发送模板短信
     * @param dxnr 模板内容
     * @param dto  条件参数(按照勾选发送，需要传入yhbhs)
     * @return
     */
    ResultRespone<Object> batchSendMessageYhqfxx(String dxnr, SmsMessageYhxxDto dto);
}
